



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>PHP学习笔记 - 进阶篇（9）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">PHP学习笔记 - 进阶篇（9）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 06:51:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>PHP学习笔记 - 进阶篇（9）</h1>
<h2>图形图像操作</h2>
<h3>GD库简介</h3>
<p>GD指的是Graphic Device，PHP的GD库是用来处理图形的扩展库，通过GD库提供的一系列API，可以对图像进行处理或者直接生成新的图片。</p>
<p>PHP除了能进行文本处理以外，通过GD库，可以对JPG、PNG、GIF、SWF等图片进行处理。GD库常用在图片加水印，验证码生成等方面。</p>
<p>PHP默认已经集成了GD库，只需要在安装的时候开启就行。</p>
<pre class="prettyprint linenums"><code>header(&quot;content-type: image/png&quot;);<br />
$img=imagecreatetruecolor(100, 100);<br />
$red=imagecolorallocate($img, 0xFF, 0x00, 0x00);<br />
imagefill($img, 0, 0, $red);<br />
imagepng($img);<br />
imagedestroy($img);<br />
</code></pre>
<h3>绘制线条</h3>
<p>要对图形进行操作，首先要新建一个画布，通过imagecreatetruecolor函数可以创建一个真彩色的空白图片：</p>
<pre class="prettyprint linenums"><code>$img = imagecreatetruecolor(100, 100);<br />
</code></pre>
<p>GD库中对于画笔所用的颜色，需要通过imagecolorallocate函数进行分配，通过参数设定RGB的颜色值来确定画笔的颜色：</p>
<pre class="prettyprint linenums"><code>$red = imagecolorallocate($img, 0xFF, 0x00, 0x00);<br />
</code></pre>
<p>然后我们通过调用绘制线段函数imageline进行线条的绘制，通过指定起点跟终点来最终得到线条。</p>
<pre class="prettyprint linenums"><code>imageline($img, 0, 0, 100, 100, $red);<br />
</code></pre>
<p>线条绘制好以后，通过header与imagepng进行图像的输出。</p>
<pre class="prettyprint linenums"><code>header(&quot;content-type: image/png&quot;);<br />
imagepng($img);<br />
</code></pre>
<p>最后可以调用imagedestroy释放该图片占用的内存。</p>
<pre class="prettyprint linenums"><code>imagedestroy($img);<br />
</code></pre>
<p>通过上面的步骤，可以发现PHP绘制图形非常的简单，但很多时候我们不只是需要输出图片，可能我们还需要得到一个图片文件，可以通过imagepng函数指定文件名将绘制后的图像保存到文件中。</p>
<pre class="prettyprint linenums"><code>imagepng($img, 'img.png');<br />
</code></pre>
<p>处理后结果如下图：<br /><br />
<img referrerpolicy="no-referrer"src="http://7xoqko.com1.z0.glb.clouddn.com/wanglongshuaiPHP_GD_image1.png"></p>
<h3>在图像中绘制文字</h3>
<p>GD库可以进行多种图形的基本操作，常用的有绘制线条，背景填充，画矩形，绘制文字等。</p>
<p>跟绘制线条类似，首先需要新建一个图片与初始化颜色。</p>
<pre class="prettyprint linenums"><code>$img = imagecreatetruecolor(100, 100);<br />
$red = imagecolorallocate($img, 0xFF, 0x00, 0x00);

</code></pre>
<p>然后使用imagestring函数来进行文字的绘制，这个函数的参数很多：<code>imagestring ( resource $image , int $font , int $x , int $y , string $s , int $col )</code>，可以通过<code>$font</code>来设置字体的大小，<code>x,y</code>设置文字显示的位置<code>，</code>$s<code>是要绘制的文字,</code>$col`是文字的颜色。</p>
<pre class="prettyprint linenums"><code>imagestring($img, 5, 0, 0, &quot;Hello world&quot;, $red);<br />
header(&quot;content-type: image/png&quot;);<br />
imagepng($img);<br />
imagedestroy($img);<br />
</code></pre>
<p>处理后结果如下图：<br /><br />
<img referrerpolicy="no-referrer"src="http://7xoqko.com1.z0.glb.clouddn.com/wanglongshuaiPHP_GD_image2.png"></p>
<h3>输出图像文件</h3>
<p>前面我们已经了解到，通过imagepng可以直接输出图像到浏览器，但是很多时候，我们希望将处理好的图像保存到文件，以便可以多次使用。通过指定路径参数将图像保存到文件中。</p>
<pre class="prettyprint linenums"><code>$filename = 'img.png';<br />
imagepng($img, $filename);<br />
</code></pre>
<p>使用imagepng可以将图像保存成png格式，如果要保存成其他格式需要使用不同的函数，使用imagejpeg将图片保存成jpeg格式，imagegif将图片保存成gif格式，需要说明的是，imagejpeg会对图片进行压缩，因此还可以设置一个质量参数。</p>
<pre class="prettyprint linenums"><code>$filename = 'img.jpg';<br />
​imagejpeg($img, $filename, 80);<br />
</code></pre>
<h3>生成图像验证码</h3>
<p>简单的验证码其实就是在图片中输出了几个字符，通过我们前面章节讲到的imagestring函数就能实现。</p>
<p>但是在处理上，为了使验证码更加的安全，防止其他程序自动识别，因此常常需要对验证码进行一些干扰处理，通常会采用绘制一些噪点，干扰线段，对输出的字符进行倾斜、扭曲等操作。</p>
<p>可以使用imagesetpixel绘制点来实现噪点干扰，但是只绘制一个点的作用不大，因此这里常常会使用循环进行随机绘制。</p>
<pre class="prettyprint linenums"><code>for($i=0;$i&lt;50;$i++) {<br />
  imagesetpixel($im, rand(0, 100) , rand(0, 100) , $black);<br />
  imagesetpixel($im, rand(0, 100) , rand(0, 100) , $green);<br />
}<br />
</code></pre>
<p>eg:</p>
<pre class="prettyprint linenums"><code>&lt;?php<br />
$img = imagecreatetruecolor(100, 40);<br />
$black = imagecolorallocate($img, 0x00, 0x00, 0x00);<br />
$green = imagecolorallocate($img, 0x00, 0xFF, 0x00);<br />
$white = imagecolorallocate($img, 0xFF, 0xFF, 0xFF);<br />
imagefill($img,0,0,$white);<br />
//生成随机的验证码<br />
$code = '';<br />
for($i = 0; $i &lt; 4; $i++) {<br />
    $code .= rand(0, 9);<br />
}<br />
imagestring($img, 5, 10, 10, $code, $black);<br />
//加入噪点干扰<br />
for($i=0;$i&lt;50;$i++) {<br />
  imagesetpixel($img, rand(0, 100) , rand(0, 100) , $black);<br />
  imagesetpixel($img, rand(0, 100) , rand(0, 100) , $green);<br />
}<br />
//输出验证码<br />
header(&quot;content-type: image/png&quot;);<br />
imagepng($img);<br />
imagedestroy($img);<br />
</code></pre>
<p>输出结果如下：</p>
<p><img referrerpolicy="no-referrer"src="http://7xoqko.com1.z0.glb.clouddn.com/wanglongshuaiPHP_GD_image3.png"></p>
<h3>给图片添加水印</h3>
<p>给图片添加水印的方法一般有两种，一种是在图片上面加上一个字符串，另一种是在图片上加上一个logo或者其他的图片。</p>
<p>因为这里处理的是已经存在的图片，所以可以直接从已存在的图片建立画布，通过imagecreatefromjpeg可以直接从图片文件创建图像。</p>
<pre class="prettyprint linenums"><code>$im = imagecreatefromjpeg($filename);<br />
</code></pre>
<p>创建图像对象以后，我们就可以通过前面的GD函数，绘制字符串到图像上。如果要加的水印是一个logo图片，那么就需要再建立一个图像对象，然后通过GD函数imagecopy将logo的图像复制到源图像中。</p>
<pre class="prettyprint linenums"><code>$logo = imagecreatefrompng($filename);<br />
imagecopy($im, $logo, 15, 15, 0, 0, $width, $height);<br />
</code></pre>
<p>当将logo图片复制到原图片上以后，将加水印后的图片输出保存就完成了加水印处理。</p>
<pre class="prettyprint linenums"><code>imagejpeg($im, $filename);<br />
</code></pre>
<p>eg:</p>
<pre class="prettyprint linenums"><code>$url = 'http://7xoqko.com1.z0.glb.clouddn.com/wanglongshuaiPHP_GD_image2.png';<br />
$content = file_get_contents($url);<br />
$filename = 'tmp.jpg';<br />
file_put_contents($filename, $content);<br />
$url ='http://7xoqko.com1.z0.glb.clouddn.com/wanglongshuaiPHP_GD_image3.png';<br />
file_put_contents('logo.png', file_get_contents($url));<br />
//开始添加水印操作<br />
$im = imagecreatefromjpeg($filename);<br />
$logo = imagecreatefrompng('logo.png');<br />
$size = getimagesize('logo.png');<br />
imagecopy($im, $logo, 15, 15, 0, 0, $size[0], $size[1]); 

header(&quot;content-type: image/jpeg&quot;);<br />
imagejpeg($im);<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4j5nqz.html">如何利用pt-online-schema-change进行MySQL表的主键变更</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlne1k8.html">IOS网络第二天 - 06-POST请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jrleeq.html">jQuery中&dollar;&lpar;function&lpar;&rpar;&lbrace;&rcub;&rpar;与&lpar;function&lpar;&dollar;&rpar;&lbrace;&rcub;&rpar;&lpar;jQuery&rpar;的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx1orv9.html">django-cms 代码研究（三）插件&lpar;plugs in&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlyyxx9.html">silverlight 跨域访问 wcf</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1pwmr9.html">How to calculate a good InnoDB log file size</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1dj639.html">信号之kill和raise函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm3d7x9.html">解密-神秘的 RunLoop</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1vdrk9.html">iotop使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnp6pv8.html">【转】Android LCD&lpar;一&rpar;：LCD基本原理篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd137k8.html">Computer Transformation&lpar;hdoj 1041&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k43269.html">&dollar;&lpar;&dollar;&lpar;&amp;&num;39&semi;&period;className&amp;&num;39&semi;&rpar;&period;html&lpar;  &rpar;选择器的工作原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgwopm8.html">Windows服务框架与服务的编写</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2pywj9.html">&lbrack;Android源码&rsqb;Android源码之高仿飞鸽传书WIFI热点搜索与创建（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4g3ek9.html">Go语言学习之3 流程控制、函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwld16k9.html">PMP 考试  形式</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1lgpx9.html">MinGW环境libssh2安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/953lz2z8.html">html -- 实体</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k1j3lq.html">Gitlab安装和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvkm0gq.html">tp框架如何处理mysql先排序在分组</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8k12g179.html">GMT、UTC、PDT 时间是什么？Linux下如何调整时区</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oky6419.html">无废话C&num;设计模式系列文章</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdwg0k8.html">C&plus;&plus;转义字符 &amp;amp&semi;amp&semi; keyword</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd723r8.html">从零开始学android开发- 应用程序窗体显示状态操作requestWindowFeature</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdek7wz9.html">STL中heap算法（堆算法）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k12xr39.html">个人对maven pom&period;xml文件的理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xd6g08.html">Jquery 表格固定表头</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w3rxlq.html">dup和dup2函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnkov6q.html">memcache 存储session</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x3olw9.html">iOS&comma;面试必看，最全梳理</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
